--- a/auto-apt-proxy
+++ b/auto-apt-proxy
@@ -24,6 +24,17 @@
 }
 trap cleanup INT EXIT TERM
 
+proxy_url() {
+	case "$1" in
+		*:*)
+			echo "http://[$1]:$2"
+		;;
+		*)
+			echo "http://$1:$2"
+		;;
+	esac
+}
+
 hit() {
   timeout 5 /usr/lib/apt/apt-helper \
     -o Acquire::http::Proxy=DIRECT -o Acquire::Retries=0 \
@@ -76,7 +87,7 @@
 
 detect_apt_cacher() {
   local ip="$1"
-  local proxy=http://$ip:3142
+  local proxy="$(proxy_url "$ip" 3142)"
   hit -o "Acquire::http::Proxy::${ip}=DIRECT" "$proxy" >/dev/null 2>&1 || true;
   if [ -s "$tmpfile" ] && grep -q -i '<title>Apt-cacher' "$tmpfile"; then
     echo "$proxy"
@@ -87,7 +98,7 @@
 
 detect_apt_cacher_ng() {
   local ip="$1"
-  local proxy=http://$ip:3142
+  local proxy="$(proxy_url "$ip" 3142)"
   if hit -o "Acquire::http::Proxy::${ip}=DIRECT" "$proxy" | grep -q -i '406.*usage.information'; then
     echo "$proxy"
     return 0
@@ -97,7 +108,7 @@
 
 detect_approx() {
   local ip="$1"
-  local proxy=http://$ip:9999
+  local proxy="$(proxy_url "$ip" 9999)"
   hit -o "Acquire::http::Proxy::${ip}=DIRECT" "$proxy" >/dev/null 2>&1 || true;
   if [ -s "$tmpfile" ] && grep -q -i '<title>approx\s*server</title>' "$tmpfile"; then
     echo "$proxy"
@@ -110,7 +121,7 @@
 #       If you want that, use squid-deb-proxy-client, which depends on avahi.
 detect_squid_deb_proxy() {
   local ip="$1"
-  local proxy=http://$ip:8000
+  local proxy="$(proxy_url "$ip" 8000)"
   if hit -oDebug::acquire::http=1 -o "Acquire::http::Proxy::${ip}=DIRECT" "$proxy" 2>&1 | grep -q 'Via: .*squid-deb-proxy'; then
     echo "$proxy"
     return 0
